import { Document, model, Schema } from 'mongoose';

export interface ResolutionInterface extends Document {
  issuer: string;
  subject: string;
  body: string;
  at: Date;
  oID: string;
  results: {
    yea: number;
    nay: number;
    present: number;
    absent: number;
  };
  acceptedAt: number;
  msg: string;
}

const Resolution = new Schema({
  issuer: { type: String, required: true },
  subject: { type: String, required: true },
  body: { type: String, required: true },
  at: { type: Date, required: true },
  oID: { type: String, required: true, unique: true },
  results: {
    yea: Number,
    Nay: Number,
    present: Number,
    absent: Number,
  },
  acceptedAt: Number,
  msg: { required: true, unique: true, type: String },
});

export default model<ResolutionInterface>('Resolutions', Resolution);
